/*
   File       : oqs_cre_tables.sql
	 Author     : Verweyen Consulting
	              Georg Verweyen
	 History    : 20070406 Creation
	 Parameters : n/a
	 Tables     : oqs_meta_data     Creation
	              oqs_kpi_type      Creation, Insert
								oqs_kpi_log       Creation
	 Description: creates three tables with metainformation
*/
CREATE TABLE oqs_meta_data (
  owner        VARCHAR2(30),
  table_name   VARCHAR2(30),
  column_name  VARCHAR2(30),
  column_len   NUMBER,
	column_type  VARCHAR2(1),
  kpi_name     VARCHAR2(82),
	kpi_type     VARCHAR2(10),
	kpi_group    VARCHAR2(30),
	kpiwh_name   VARCHAR2(30),
	kpiwh_type   VARCHAR2(1),
	kpiwh_value  VARCHAR2(20)
);

CREATE TABLE oqs_kpi_type (
  kpi_type     VARCHAR2(10),
	column_type  VARCHAR2(1),
	statement_1  VARCHAR2(80),
  statement_2  VARCHAR2(80),
	result_type  VARCHAR2(1),
	null_count   VARCHAR2(1),
	active       VARCHAR2(1)
);

INSERT INTO oqs_kpi_type VALUES ('SUM',     'N','sum(',           ')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('MIN',     'N','min(',           ')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('MIN',     'V','min(',           ')'          ,'V','N','Y');
INSERT INTO oqs_kpi_type VALUES ('MAX',     'N','max(',           ')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('MAX',     'V','max(',           ')'          ,'V','N','Y');
INSERT INTO oqs_kpi_type VALUES ('DISTINCT','N','count(distinct ',')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('DISTINCT','V','count(distinct ',')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('COUNT',   'N','count(',         ')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('COUNT',   'V','count(',         ')'          ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('NULL',    'N','sum(decode(',    ',NULL,1,0))','N','Y','Y');
INSERT INTO oqs_kpi_type VALUES ('NULL',    'V','sum(decode(',    ',NULL,1,0))','N','Y','Y');
INSERT INTO oqs_kpi_type VALUES ('MIN-LEN', 'V','min(length(',    '))'         ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('MAX-LEN', 'V','max(length(',    '))'         ,'N','N','Y');
INSERT INTO oqs_kpi_type VALUES ('SUM-LEN', 'V','sum(length(',    '))'         ,'N','N','Y');
COMMIT;

CREATE TABLE oqs_kpi_log_run (
  kpi_time      DATE,
	kpi_name      VARCHAR2(82),
	kpi_type      VARCHAR2(1),
	kpi_c_val     VARCHAR2(2000),
  kpi_n_val     NUMBER,
	kpi_group_val VARCHAR2(2000)
);
